#pragma once

#include <filesystem>
#include <mutex>
#include <optional>

#include <RobotAPI/libraries/armem/server/ltm/LongtermMemoryBase.h>


namespace armarx::armem::server::ltm::disk
{
    /// @brief A memory storing data in mongodb (needs 'armarx memory start' to start the mongod instance)
    class MemoryManager : public LongtermMemoryBase
    {
        using Base = LongtermMemoryBase;

    public:
        MemoryManager() = default;

        void reload() override;
        void convert(armem::wm::Memory&) override;
        void encodeAndStore() override;

        void
        setBasePath(const std::filesystem::path& p)
        {
            basePathToMemory = p;
        }

    protected:
    private:
        bool checkPath() const;

    public:
        std::filesystem::path basePathToMemory;

    private:
        static const constexpr char* TYPE_FILENAME = "type.aron.ltm.json";
        static const constexpr char* DATA_FILENAME = "data.aron.ltm.json";
    };

} // namespace armarx::armem::server::ltm::disk
